package edu.gustavus.mcs178.npuzzle.v5;

/**
 * @author Max Hailperin, Barbara Kaiser, and Karl Knight
 * 
 * This file contains excerpts from the textbook Concrete Abstractions: An Introduction to Computer Science Using Scheme,
 * by Max Hailperin, Barbara Kaiser, and Karl Knight, Copyright (c) 1998 by the authors. Full text is available for free
 * at http://www.gustavus.edu/+max/concrete-abstractions.html
 * 
 * Modified by Karl Knight in May 2011 to use Java Swing
 */
public class PoltergeistThread extends Thread {

	private Puzzle puzzle;

	public PoltergeistThread(Puzzle puzzle) {
		this.puzzle = puzzle;
	}

	public void run() {
		try {
			while(true) {
				Thread.sleep(1000); // 1000 milliseconds = 1 second
				puzzle.pushRandomTile();
			}
		} catch (InterruptedException e){
			// If the thread is forcibly interrupted while sleeping,
			// an exception gets thrown that is caught here. However,
			// we can't really do anything, except stop running.
		}
	}
}
